Index: /LMDZ5/branches/testing/libf/dyn3d/dynredem_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d/dynredem_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d/dynredem_mod.F90	(revision 2408)
@@ -0,0 +1,219 @@
+MODULE dynredem_mod
+
+  USE netcdf
+  PRIVATE
+  PUBLIC :: dynredem_write_u, dynredem_write_v, dynredem_read_u, err
+  PUBLIC :: cre_var, get_var1, put_var1, put_var2, fil, modname, msg
+  include "dimensions.h"
+  include "paramet.h"
+  CHARACTER(LEN=256), SAVE :: fil, modname
+  INTEGER,            SAVE :: nvarid
+
+
+CONTAINS
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(iip1,jjp1,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  INTEGER :: start(4), count(4)
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,ll,1]
+  CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+  CALL err(NF90_PUT_VAR(ncid,nvarid,var,start,count),"put",id)
+  
+END SUBROUTINE dynredem_write_u
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_v(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(iip1,jjm,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  INTEGER :: start(4), count(4)
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjm,ll,1]
+  CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+  CALL err(NF90_PUT_VAR(ncid,nvarid,var,start,count),"put",id)
+  
+END SUBROUTINE dynredem_write_v
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_read_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN)  :: ncid
+  CHARACTER(LEN=*), INTENT(IN)  :: id
+  REAL,             INTENT(OUT) :: var(iip1,jjp1,ll)
+  INTEGER,          INTENT(IN)  :: ll
+!===============================================================================
+! Local variables:
+  INTEGER :: start(4), count(4)
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,ll,1]
+  CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+  CALL err(NF90_GET_VAR(ncid,nvarid,var,start,count),"get",id)
+  
+END SUBROUTINE dynredem_read_u    
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE cre_var(ncid,var,title,did,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
+#ifdef NC_DOUBLE
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_DOUBLE,did,nvarid),"inq",var)
+#else
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_FLOAT ,did,nvarid),"inq",var)
+#endif
+  IF(title/="")      CALL err(NF90_PUT_ATT(ncid,nvarid,"title",title),var)
+  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(ncid,nvarid,"units",units),var)
+
+END SUBROUTINE cre_var
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE put_var1(ncid,var,title,did,v,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(1)
+  REAL,                       INTENT(IN) :: v(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
+  IF(     PRESENT(units)) CALL cre_var(ncid,var,title,did,units)
+  IF(.NOT.PRESENT(units)) CALL cre_var(ncid,var,title,did)
+  CALL err(NF90_ENDDEF(ncid))
+  CALL err(NF90_PUT_VAR(ncid,nvarid,v),"put",var)
+  CALL err(NF90_REDEF(ncid))
+
+END SUBROUTINE put_var1
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE put_var2(ncid,var,title,did,v,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(2)
+  REAL,                       INTENT(IN) :: v(:,:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
+  IF(     PRESENT(units)) CALL cre_var(ncid,var,title,did,units)
+  IF(.NOT.PRESENT(units)) CALL cre_var(ncid,var,title,did)
+  CALL err(NF90_ENDDEF(ncid))
+  CALL err(NF90_PUT_VAR(ncid,nvarid,v),"put",var)
+  CALL err(NF90_REDEF(ncid))
+
+END SUBROUTINE put_var2
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+FUNCTION msg(typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=256)                     :: msg    !--- STANDARDIZED MESSAGE
+  CHARACTER(LEN=*),           INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  SELECT CASE(typ)
+    CASE('open');  msg="Opening failed for <"//TRIM(fil)//">"
+    CASE('close'); msg="Closing failed for <"//TRIM(fil)//">"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('put');   msg="Writting failed for <"//TRIM(nam)//">"
+    CASE('inq');   msg="Missing field <"//TRIM(nam)//">"
+    CASE('fnd');   msg="Found field <"//TRIM(nam)//">"
+  END SELECT
+  msg=TRIM(msg)//" in file <"//TRIM(fil)//">"
+
+END FUNCTION msg
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE err(ierr,typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  IF(ierr==NF90_NoERR) RETURN
+  IF(.NOT.PRESENT(typ)) THEN
+    CALL ABORT_gcm(modname,NF90_STRERROR(ierr),ierr)
+  ELSE
+    CALL ABORT_gcm(modname,msg(typ,nam),ierr)
+  END IF
+
+END SUBROUTINE err
+!
+!===============================================================================
+
+END MODULE dynredem_mod   
+    
+    
Index: /LMDZ5/branches/testing/libf/dyn3d/gcm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d/gcm.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3d/gcm.F90	(revision 2408)
@@ -22,10 +22,6 @@
   USE infotrac
   USE control_mod
-
-#ifdef INCA
-  ! Only INCA needs these informations (from the Earth's physics)
-  USE indice_sol_mod
-  USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
-#endif
+  USE mod_const_mpi, ONLY: COMM_LMDZ
+
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -34,6 +30,5 @@
   ! dynamique -> physique pour l'initialisation
 #ifdef CPP_PHYS
-  !      USE dimphy
-  !      USE comgeomphy
+  USE iniphysiq_mod, ONLY: iniphysiq
 #endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -86,8 +81,4 @@
   include "iniprint.h"
   include "tracstoke.h"
-#ifdef INCA
-  ! Only INCA needs these informations (from the Earth's physics)
-  !include "indicesol.h"
-#endif
 
   REAL zdtvr
@@ -182,8 +173,8 @@
   ! A nettoyer. On ne veut qu'une ou deux routines d'interface 
   ! dynamique -> physique pour l'initialisation
-#ifdef CPP_PHYS
-  CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
-  !      call InitComgeomphy ! now done in iniphysiq
-#endif
+!#ifdef CPP_PHYS
+!  CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+!  !      call InitComgeomphy ! now done in iniphysiq
+!#endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !-----------------------------------------------------------------------
@@ -209,12 +200,4 @@
 #endif
   !-----------------------------------------------------------------------
-
-  IF (type_trac == 'inca') THEN
-#ifdef INCA
-     call init_const_lmdz(nbtr,anneeref,dayref,iphysiq,day_step,nday,  &
-          nbsrf, is_oce,is_sic,is_ter,is_lic)
-     call init_inca_para(iim,jjm+1,klon,1,klon_mpi_para_nb,0)
-#endif
-  END IF
   !
   !
@@ -260,11 +243,4 @@
 
   endif ! of if (read_start)
-
-  IF (type_trac == 'inca') THEN
-#ifdef INCA
-     call init_inca_dim(klon,llm,iim,jjm, &
-          rlonu,rlatu,rlonv,rlatv)
-#endif
-  END IF
 
 
@@ -416,6 +392,8 @@
      ! Physics:
 #ifdef CPP_PHYS
-     CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys, &
-          rlatu,rlonv,aire,cu,cv,rad,g,r,cpp, &
+     CALL iniphysiq(iim,jjm,llm, &
+          (jjm-1)*iim+2,comm_lmdz, &
+          daysec,day_ini,dtphys/nsplit_phys, &
+          rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp, &
           iflag_phys)
 #endif
Index: /LMDZ5/branches/testing/libf/dyn3d/leapfrog.F
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 2407)
+++ /LMDZ5/branches/testing/libf/dyn3d/leapfrog.F	(revision 2408)
@@ -228,8 +228,11 @@
    1  CONTINUE ! Matsuno Forward step begins here
 
+c   date: (NB: date remains unchanged for Backward step)
+c   -----
+
       jD_cur = jD_ref + day_ini - day_ref +                             &
-     &          itau/day_step
+     &          (itau+1)/day_step
       jH_cur = jH_ref + start_time +                                    &
-     &          mod(itau,day_step)/float(day_step) 
+     &          mod(itau+1,day_step)/float(day_step) 
       jD_cur = jD_cur + int(jH_cur)
       jH_cur = jH_cur - int(jH_cur)
@@ -277,6 +280,15 @@
 c-----------------------------------------------------------------------
 
-c   date:
+c   date: (NB: only leapfrog step requires recomputing date)
 c   -----
+
+      IF (leapf) THEN
+        jD_cur = jD_ref + day_ini - day_ref +
+     &            (itau+1)/day_step
+        jH_cur = jH_ref + start_time +
+     &            mod(itau+1,day_step)/float(day_step) 
+        jD_cur = jD_cur + int(jH_cur)
+        jH_cur = jH_cur - int(jH_cur)
+      ENDIF
 
 
@@ -416,5 +428,5 @@
 !     &              (itau * dtvr / daysec - int(itau * dtvr / daysec)) 
            jD_cur = jD_ref + day_ini - day_ref +                        &
-     &          itau/day_step
+     &          (itau+1)/day_step
 
            IF (planet_type .eq."generic") THEN
@@ -424,5 +436,5 @@
 
            jH_cur = jH_ref + start_time +                               &
-     &              mod(itau,day_step)/float(day_step) 
+     &              mod(itau+1,day_step)/float(day_step) 
            jD_cur = jD_cur + int(jH_cur)
            jH_cur = jH_cur - int(jH_cur)
@@ -443,10 +455,8 @@
          IF (ip_ebil_dyn.ge.1 ) THEN 
           ztit='bil dyn'
-! Ehouarn: be careful, diagedyn is Earth-specific (includes ../phylmd/..)!
+! Ehouarn: be careful, diagedyn is Earth-specific!
            IF (planet_type.eq."earth") THEN
-#ifdef CPP_EARTH
             CALL diagedyn(ztit,2,1,1,dtphys
      &    , ucov    , vcov , ps, p ,pk , teta , q(:,:,1), q(:,:,2))
-#endif
            ENDIF
          ENDIF ! of IF (ip_ebil_dyn.ge.1 )
Index: /LMDZ5/branches/testing/libf/dyn3d_common/caldyn0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/caldyn0.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/caldyn0.F90	(revision 2408)
@@ -0,0 +1,56 @@
+SUBROUTINE caldyn0(itau,ucov,vcov,teta,ps,masse,pk,phis,phi,w,pbaru,pbarv,time)
+!
+!-------------------------------------------------------------------------------
+! Author: P. Le Van ; modif. 04/93: F.Forget.
+!-------------------------------------------------------------------------------
+! Purpose: Compute dynamic tendencies.
+!-------------------------------------------------------------------------------
+  USE control_mod, ONLY: resetvarc 
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comvert.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  INTEGER, INTENT(IN)  :: itau                      !--- TIME STEP INDEX
+  REAL,    INTENT(IN)  :: vcov (ip1jm    ,llm)      !--- V COVARIANT WIND
+  REAL,    INTENT(IN)  :: ucov (ip1jmp1  ,llm)      !--- U COVARIANT WIND
+  REAL,    INTENT(IN)  :: teta (ip1jmp1  ,llm)      !--- POTENTIAL TEMPERATURE
+  REAL,    INTENT(IN)  :: ps   (ip1jmp1)            !--- GROUND PRESSURE
+  REAL,    INTENT(OUT) :: masse(ip1jmp1  ,llm)      !--- MASS IN EACH CELL
+  REAL,    INTENT(IN)  :: pk   (iip1,jjp1,llm)      !--- PRESSURE
+  REAL,    INTENT(IN)  :: phis (ip1jmp1)            !--- GROUND GEOPOTENTIAL
+  REAL,    INTENT(IN)  :: phi  (ip1jmp1  ,llm)      !--- 3D GEOPOTENTIAL
+  REAL,    INTENT(OUT) :: w    (ip1jmp1  ,llm)      !--- VERTICAL WIND
+  REAL,    INTENT(OUT) :: pbaru(ip1jmp1  ,llm)      !--- U MASS FLUX
+  REAL,    INTENT(OUT) :: pbarv(ip1jm    ,llm)      !--- V MASS FLUX
+  REAL,    INTENT(IN)  :: time                      !--- TIME
+!===============================================================================
+! Local variables:
+  REAL, DIMENSION(ip1jmp1,llmp1) :: p
+  REAL, DIMENSION(ip1jmp1,llm)   :: ucont, massebx, ang, ecin, convm, bern
+  REAL, DIMENSION(ip1jmp1)       :: dp
+  REAL, DIMENSION(ip1jm  ,llm)   :: vcont, masseby, massebxy, vorpot
+  REAL, DIMENSION(ip1jm)         :: psexbarxy
+  INTEGER                        :: ij, l
+!===============================================================================
+  CALL covcont  ( llm    , ucov    , vcov , ucont, vcont        )
+  CALL pression ( ip1jmp1, ap      , bp   ,  ps  , p            )
+  CALL psextbar (   ps   , psexbarxy                            )
+  CALL massdair (    p   , masse                                )
+  CALL massbar  (   masse, massebx , masseby                    )
+  CALL massbarxy(   masse, massebxy                             )
+  CALL flumass  ( massebx, masseby , vcont, ucont ,pbaru, pbarv )
+  CALL convmas  (   pbaru, pbarv   , convm                      )
+  CALL vitvert  ( convm  , w                                    )
+  CALL tourpot  ( vcov   , ucov    , massebxy  , vorpot         )
+  CALL enercin  ( vcov   , ucov    , vcont     , ucont  , ecin  )
+  CALL bernoui  ( ip1jmp1, llm     , phi       , ecin   , bern  )
+  DO l=1,llm; ang(:,l) = ucov(:,l) + constang(:); END DO
+  resetvarc=.true. ! force a recomputation of initial values in sortvarc
+  dp(:)=convm(:,1)/airesurg(:)
+  CALL sortvarc( itau,ucov,teta,ps,masse,pk,phis,vorpot,phi,bern,dp,time,vcov )
+
+END SUBROUTINE caldyn0
Index: /LMDZ5/branches/testing/libf/dyn3d_common/conf_dat_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/conf_dat_m.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/conf_dat_m.F90	(revision 2408)
@@ -0,0 +1,235 @@
+MODULE conf_dat_m
+!
+!*******************************************************************************
+
+  PRIVATE
+  PUBLIC :: conf_dat2d, conf_dat3d
+
+
+CONTAINS
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE conf_dat2d(title, xd, yd, xf, yf, champd, interbar)
+!
+!-------------------------------------------------------------------------------
+! Author: P. Le Van
+!-------------------------------------------------------------------------------
+! Purpose: Configure the 2D data field "champd" so that:
+!     - Longitudes are in [ -pi     pi   ]
+!     - Latitudes  are in [  pi/2. -pi/2 ]
+!  * xd / yd are initial lon / lats.
+!  * xf / yf are output  lon / lats, possibly modified to satisfy configuration.
+!  * interbar is TRUE for barycentric interpolation.
+!-------------------------------------------------------------------------------
+  USE assert_eq_m, ONLY: assert_eq
+  IMPLICIT NONE
+!-------------------------------------------------------------------------------
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN)    :: title
+  REAL,             INTENT(IN)    :: xd(:), yd(:)  ! dim (lons) (lats)
+  REAL,             INTENT(INOUT) :: xf(:), yf(:)  ! dim (lons) (lats)
+  REAL,             INTENT(INOUT) :: champd(:,:)   ! dim (lons,lats)
+  LOGICAL,          INTENT(IN)    :: interbar
+!-------------------------------------------------------------------------------
+! Local variables:
+  CHARACTER(LEN=256) :: modname="conf_dat2d"
+  INTEGER :: i, j, ip180, ind, lons, lats
+  LOGICAL :: radlon, invlon ,radlat, invlat
+  REAL    :: pi, pis2, depi, rlatmin, rlatmax, oldxd1
+  REAL, ALLOCATABLE :: xtemp(:) , ytemp(:), champf(:,:)
+!-------------------------------------------------------------------------------
+  lons=assert_eq(SIZE(xd),SIZE(xf),SIZE(champd,1),TRIM(modname)//" lons")
+  lats=assert_eq(SIZE(yd),SIZE(yf),SIZE(champd,2),TRIM(modname)//" lats")
+  ALLOCATE(xtemp(lons),ytemp(lats)); xtemp(:)=xd(:); ytemp(:)=yd(:)
+  ALLOCATE(champf(lons,lats))
+  pi = 2. * ASIN(1.) 
+  pis2 = pi/2.
+  depi = 2. * pi
+  radlon=.FALSE.; invlon=.FALSE.
+  IF     (xtemp(1)>=-pi-0.5.AND.xtemp(lons)<=  pi+0.5) THEN
+    radlon = .TRUE.;  invlon = .FALSE.
+  ELSE IF(xtemp(1)>=   -0.5.AND.xtemp(lons)<=depi+0.5) THEN
+    radlon = .TRUE.;  invlon = .TRUE.
+  ELSE IF(xtemp(1)>= -180.5.AND.xtemp(lons)<=   180.5) THEN
+    radlon = .FALSE.; invlon = .FALSE.
+  ELSE IF(xtemp(1)>=   -0.5.AND.xtemp(lons)<=   360.5) THEN
+    radlon = .FALSE.; invlon = .TRUE.
+  ELSE; WRITE(6,*) 'Problems with data longitudes for file '//TRIM(title)
+  END IF
+  invlat = ytemp(1)<ytemp(lats)
+  rlatmin = MIN( ytemp(1), ytemp(lats) )
+  rlatmax = MAX( ytemp(1), ytemp(lats) )
+      
+  IF     (rlatmin>=-pis2-0.5.AND.rlatmax<=pis2+0.5) THEN; radlat = .TRUE.
+  ELSE IF(rlatmin>= -90.-0.5.AND.rlatmax<= 90.+0.5) THEN; radlat = .FALSE.
+  ELSE; WRITE(6,*) 'Problems with data latitudes for file '//TRIM(title)
+  END IF
+
+  IF(.NOT.radlon) xtemp(:)=xtemp(:)*pi/180.
+  IF(.NOT.radlat) ytemp(:)=ytemp(:)*pi/180.
+
+!--- FLIPPED LONGITUDES
+  IF(invlon) THEN
+    champf(:,:)=champd(:,:); xf(:)=xtemp(:)
+
+  !--- Longitudes rotated to get them in [ -pi pi] interval.
+    DO i=1,lons;      IF(xf(i)>pi) EXIT;                   END DO; ip180 = i
+    DO i=1,lons;      IF(xf(i)>pi) xf(i)=xf(i)-depi;       END DO
+    DO i= ip180,lons; ind=i-ip180+1; xtemp(ind)=xf(i);     END DO
+    DO i= ind+1,lons;                xtemp(i  )=xf(i-ind); END DO
+
+  !--- Longitudes rotated in champf
+    DO j=1,lats
+      DO i=ip180,lons; ind=i-ip180+1; champd(ind,j)=champf(i    ,j); END DO
+      DO i=ind+1,lons;                champd(i  ,j)=champf(i-ind,j); END DO
+    END DO
+  END IF
+
+!--- FLIPPED LATITUDES
+  IF(invlat) THEN
+    yf(:)=ytemp(:)
+    champf(:,:)=champd(:,:)
+    ytemp(lats:1:-1)=yf(:)
+    DO j=1,lats; champd(:,lats-j+1)=champf(:,j); END DO
+  END IF
+
+!--- FOR BARYCENTRIC INTERPOLATION
+  IF(interbar) THEN
+    oldxd1 = xtemp(1)
+    xtemp(1:lons-1)=0.5*(xtemp(1:lons-1)+xtemp(2:lons))
+    xtemp(  lons  )=0.5*(xtemp(  lons  )+oldxd1+depi)
+    ytemp(1:lats-1)=0.5*(ytemp(1:lats-1)+ytemp(2:lats))
+  END IF
+  DEALLOCATE(champf)
+  xf(:)=xtemp(:); DEALLOCATE(xtemp)
+  yf(:)=ytemp(:); DEALLOCATE(ytemp)
+
+END SUBROUTINE conf_dat2d
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE conf_dat3d(title, xd, yd, zd, xf, yf, zf, champd, interbar)
+!
+!-------------------------------------------------------------------------------
+! Author: P. Le Van
+!-------------------------------------------------------------------------------
+! Purpose: Configure the 3D data field "champd" so that:
+!     - Longitudes are in [ -pi     pi   ]
+!     - Latitudes  are in [  pi/2. -pi/2 ]
+!     - Vertical levels from ground to model top (in Pascals)
+!  * xd / yd are initial lon / lats.
+!  * xf / yf are output  lon / lats, possibly modified to satisfy configuration.
+!  * zf      are output pressures
+!  * interbar is TRUE for barycentric interpolation.
+!-------------------------------------------------------------------------------
+  USE assert_eq_m, ONLY: assert_eq
+  IMPLICIT NONE
+!-------------------------------------------------------------------------------
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN)    :: title
+  REAL,             INTENT(IN)    :: xd(:), yd(:), zd(:) ! (lons) (lats) (levs)
+  REAL,             INTENT(INOUT) :: xf(:), yf(:), zf(:) ! (lons) (lats) (levs)
+  REAL,             INTENT(INOUT) :: champd(:,:,:)       ! (lons,lats,levs)
+  LOGICAL,          INTENT(IN)    :: interbar
+!-------------------------------------------------------------------------------
+! Local variables:
+  CHARACTER(LEN=256) :: modname="conf_dat3d"
+  INTEGER :: i, j, l, ip180, ind, lons, lats, levs
+  LOGICAL :: radlon, invlon ,radlat, invlat, invlev
+  REAL    :: pi, pis2, depi, presmax, rlatmin, rlatmax, oldxd1
+  REAL, ALLOCATABLE :: xtemp(:) , ytemp(:), ztemp(:), champf(:,:,:)
+!-------------------------------------------------------------------------------
+  lons=assert_eq(SIZE(xd),SIZE(xf),SIZE(champd,1),TRIM(modname)//" lons")
+  lats=assert_eq(SIZE(yd),SIZE(yf),SIZE(champd,2),TRIM(modname)//" lats")
+  levs=assert_eq(SIZE(zd),SIZE(zf),SIZE(champd,3),TRIM(modname)//" levs")
+  ALLOCATE(xtemp(lons),ytemp(lats),ztemp(levs),champf(lons,lats,levs))
+  xtemp(:)=xd(:); ytemp(:)=yd(:); ztemp(:)=zd(:)
+  pi = 2. * ASIN(1.) 
+  pis2 = pi/2.
+  depi = 2. * pi
+  radlon=.FALSE.; invlon=.FALSE.
+  IF     (xtemp(1)>=-pi-0.5.AND.xtemp(lons)<=  pi+0.5) THEN
+    radlon = .TRUE.;  invlon = .FALSE.
+  ELSE IF(xtemp(1)>=   -0.5.AND.xtemp(lons)<=depi+0.5) THEN
+    radlon = .TRUE.;  invlon = .TRUE.
+  ELSE IF(xtemp(1)>= -180.5.AND.xtemp(lons)<=   180.5) THEN
+    radlon = .FALSE.; invlon = .FALSE.
+  ELSE IF(xtemp(1)>=   -0.5.AND.xtemp(lons)<=   360.5) THEN
+    radlon = .FALSE.; invlon = .TRUE.
+  ELSE; WRITE(6,*) 'Problems with data longitudes for file '//TRIM(title)
+  END IF
+  invlat = ytemp(1)<ytemp(lats)
+  rlatmin = MIN( ytemp(1), ytemp(lats) )
+  rlatmax = MAX( ytemp(1), ytemp(lats) )
+      
+  IF     (rlatmin>=-pis2-0.5.AND.rlatmax<=pis2+0.5) THEN; radlat = .TRUE.
+  ELSE IF(rlatmin>= -90.-0.5.AND.rlatmax<= 90.+0.5) THEN; radlat = .FALSE.
+  ELSE; WRITE(6,*) 'Problems with data latitudes for file '//TRIM(title)
+  END IF
+
+  IF(.NOT.radlon) xtemp(:)=xtemp(:)*pi/180.
+  IF(.NOT.radlat) ytemp(:)=ytemp(:)*pi/180.
+
+!--- FLIPPED LONGITUDES
+  IF(invlon) THEN
+    champf(:,:,:)=champd(:,:,:); xf(:)=xtemp(:)
+
+  !--- Longitudes rotated to get them in [ -pi pi] interval.
+    DO i=1,lons;      IF(xf(i)>pi) EXIT;                   END DO; ip180 = i
+    DO i=1,lons;      IF(xf(i)>pi) xf(i)=xf(i)-depi;       END DO
+    DO i= ip180,lons; ind=i-ip180+1; xtemp(ind)=xf(i);     END DO
+    DO i= ind+1,lons;                xtemp(i  )=xf(i-ind); END DO
+
+  !--- Longitudes rotated in champf
+    DO l=1,levs
+    DO j=1,lats
+      DO i=ip180,lons; ind=i-ip180+1; champd(ind,j,l)=champf(i    ,j,l); END DO
+      DO i=ind+1,lons;                champd(i  ,j,l)=champf(i-ind,j,l); END DO
+    END DO
+    END DO
+  END IF
+
+!--- FLIPPED LATITUDES
+  IF(invlat) THEN
+    yf(:)=ytemp(:)
+    champf(:,:,:)=champd(:,:,:)
+    ytemp(lats:1:-1)=yf(:)
+    DO l=1,levs
+      DO j=1,lats; champd(:,lats-j+1,l)=champf(:,j,l); END DO
+    END DO
+  END IF
+
+!--- FOR BARYCENTRIC INTERPOLATION
+  IF(interbar) THEN
+    oldxd1 = xtemp(1)
+    xtemp(1:lons-1)=0.5*(xtemp(1:lons-1)+xtemp(2:lons))
+    xtemp(  lons  )=0.5*(xtemp(  lons  )+oldxd1+depi)
+    ytemp(1:lats-1)=0.5*(ytemp(1:lats-1)+ytemp(2:lats))
+  END IF
+
+!--- FLIPPED LEVELS
+  invlev=ztemp(1)<ztemp(levs)
+  IF(MAX(ztemp(1),ztemp(levs))<1200.) ztemp(:)=ztemp(:)*100.
+  IF(invlev) THEN
+    zf(:)=ztemp(:)
+    champf(:,:,:)=champd(:,:,:)
+    ztemp(levs:1:-1)=zf(:)
+    DO l=1,levs; champd(:,:,levs+1-l)=champf(:,:,l); END DO
+  END IF
+
+  DEALLOCATE(champf)
+  xf(:)=xtemp(:); DEALLOCATE(xtemp)
+  yf(:)=ytemp(:); DEALLOCATE(ytemp)
+  zf(:)=ztemp(:); DEALLOCATE(ztemp)
+
+END SUBROUTINE conf_dat3d
+!
+!-------------------------------------------------------------------------------
+
+END MODULE conf_dat_m
+
Index: /LMDZ5/branches/testing/libf/dyn3d_common/convmas.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/convmas.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/convmas.F90	(revision 2408)
@@ -0,0 +1,36 @@
+SUBROUTINE convmas (pbaru, pbarv, convm)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute mass flux convergence at p levels.
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: pbaru(ip1jmp1,llm)
+  REAL, INTENT(IN)  :: pbarv(ip1jm  ,llm)
+  REAL, INTENT(OUT) :: convm(ip1jmp1,llm)
+!===============================================================================
+! Method used:   Computation from top to bottom.
+!   Mass convergence at level llm is equal to zero and is not stored in convm.
+!===============================================================================
+! Local variables:
+  INTEGER :: l
+!===============================================================================
+
+!--- Computation of - (d(pbaru)/dx + d(pbarv)/dy )
+  CALL convflu( pbaru, pbarv, llm, convm )
+
+!--- Filter
+  CALL filtreg( convm, jjp1, llm, 2, 2, .TRUE., 1 )
+
+!--- Mass convergence is integrated from top to bottom
+  DO l=llmm1,1,-1
+    convm(:,l) = convm(:,l) + convm(:,l+1)
+  END DO
+
+END SUBROUTINE convmas
Index: /LMDZ5/branches/testing/libf/dyn3d_common/covcont.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d_common/covcont.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d_common/covcont.F90	(revision 2408)
@@ -0,0 +1,29 @@
+SUBROUTINE covcont (klevel,ucov, vcov, ucont, vcont )
+!
+!-------------------------------------------------------------------------------
+! Author: P. Le Van
+!-------------------------------------------------------------------------------
+! Purpose: Compute contravariant components from covariant components.
+!-------------------------------------------------------------------------------
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  INTEGER, INTENT(IN)  :: klevel                    !--- VERTICAL LEVELS NUMBER
+  REAL,    INTENT(IN)  :: ucov ( ip1jmp1,klevel )   !--- U COVARIANT WIND
+  REAL,    INTENT(IN)  :: vcov ( ip1jm  ,klevel )   !--- V COVARIANT WIND
+  REAL,    INTENT(OUT) :: ucont( ip1jmp1,klevel )   !--- U CONTRAVAR WIND
+  REAL,    INTENT(OUT) :: vcont( ip1jm  ,klevel )   !--- V CONTRAVAR WIND
+!===============================================================================
+!   Local variables:
+  INTEGER :: l
+!===============================================================================
+  DO l=1,klevel
+    ucont(iip2:ip1jm,l)=ucov(iip2:ip1jm,l) * unscu2(iip2:ip1jm)
+    vcont(   1:ip1jm,l)=vcov(   1:ip1jm,l) * unscv2(   1:ip1jm)
+  END DO
+
+END SUBROUTINE covcont
+
